;==============================================================================
; ėp[`
;==============================================================================

;==============================================================================
; Tu[` ---- ADDHLA ... HL+A=HL
;------------------------------------------------------------------------------
; [] ..... HL=l1
;              A =l2i̐j
; [j] ..... HL
; [o] ..... HL=HL+A
; [p] ... 
; [l] ..... 
;------------------------------------------------------------------------------
ADDHLA:
	ADD	A, L
	LD	L, A
	RET	NC
	INC	H
        RET

;==============================================================================
; Tu[` ---- AXBHL ... A~B=HL
;------------------------------------------------------------------------------
; [] ..... A =l1i̐j
;              B =l2i̐j
; [j] ..... AF/B/HL
; [o] ..... HL=l1ƒl2̏Z̒l
; [p] ... 
; [l] ..... ASY͕MZ^Cv
;------------------------------------------------------------------------------
AXBHL:
	PUSH	DE
	LD	HL, 0		; ʂNA
	LD	D, H		
	LD	E, B		; DE=B
	LD	B, 8		; 8bitԂJԂ(counter)
AXBHL00:
	RRCA			; ŉbitCyɓ
	JR	NC, AXBHL01	;
	ADD	HL, DE		; Cy=1ȂDE
AXBHL01:
	SLA	E
	RL	D		; DEVtg
	DJNZ	AXBHL00
	POP	DE
	RET

;==============================================================================
; Tu[` ---- DIVHLBC ... HLBC=DE܂HL
;------------------------------------------------------------------------------
; [] ..... HL=l1i̐j
;              BC=l2i̐j
; [j] ..... AF/BC/DE/HL
; [o] ..... 
; [p] ... 
; [l] ..... 
;------------------------------------------------------------------------------
DIVHLBC:
	LD	A, B
	OR	C		; BC=0H & CytOZbg
	RET	Z		; BC=0̎̓G[(DIV/0)
DIVHLBC00:
	LD	DE, 0		; 
	AND	A		; CytOZbg
DIVHLBC01:
	SBC	HL, BC		
	JR	C, DIVHLBC02	; 甲
	INC	DE		; ++
	JR	DIVHLBC01
DIVHLBC02:
	ADD	HL, BC		; HL=܂
	RET

;------------------------------------------------------------------------------
;DIVDEBC:
;	LD	HL, 0
;	LD	A, 16
;DIVDEBC01:
;	SLA	E
;	RL	D
;	ADC	HL, HL
;	SBC	HL, BC
;	JR	C, DIVDEBC02
;	INC	E
;	JR	DIVDEBC03
;DIVDEBC02:
;	ADD	HL, BC
;DIVDEBC03:
;	DEC	A
;	JR	NZ, DIVDEBC01
;	RET

;==============================================================================
; Tu[` ---- DIVAB ... AB=C܂A
;------------------------------------------------------------------------------
; [] ..... A =l1i̐j
;              B =l2i̐j
; [j] ..... AF/BC
; [o] ..... 
; [p] ... 
; [l] ..... 
;------------------------------------------------------------------------------
DIVAB:
	INC	B
	DEC	B
	RET	Z		; B=0̎̓G[(DIV0)
DIVAB00:
	LD	C, 0		; 
DIVAB01:
	SUB	B
	JR	C, DIVAB02 	; 甲
	INC	C		; ++
	JR	DIVAB01
DIVAB02:
	ADD	A, B		; A=܂
	RET

;==============================================================================
; Tu[` ---- NEXT_LINE ... BC+80isZoj
;------------------------------------------------------------------------------
; [] ... BC=VRAMAhX
; [o] ... BC=VRAMAhX
; [j] ... Ȃ
;------------------------------------------------------------------------------
NEXT_LINE:
	PUSH	HL
	LD	HL, 80
	ADD	HL, BC
	LD	B, H
	LD	C, L
	POP	HL
	RET

;==============================================================================
; Tu[` ---- FILLMEM ... w͈͂̃𓯂lŖ
;------------------------------------------------------------------------------
; [] ... A =l
;            HL=JnAhX
;            BC=JE^(TCY)
; [j] ... F/BC/DE/HL
;------------------------------------------------------------------------------
FILLMEM:
	LD	D, H		; DE=HL
	LD	E, L
	INC	DE		; DE=]AhX
	DEC	BC		; 
	LD	(HL), A		; 擪AhXɒ`
	LDIR			; `AhX̓eDẼAhXɓ]
	RET

